<?php
/**
 * users.php created for jts3servermod
 * Author: monster010
 * Date: 10.03.2020
 * Time: 19:55
 */

require_once("include/formularfunctions.php");
require_once("class/TFA.php");

function getCSSListComboBoxDef($name, $default) {
	$formChooser = "<select name=\"".$name."\" id=\"".$name."\" size=\"1\" class=\"form-control\">\n";

	$cssFiles = scandir('assets/styles');
	$includes = [];

	foreach ($cssFiles as $file) {
		if ($file == "." || $file == "..") continue;

		$file = str_replace('.css', '', $file);
		$file = str_replace('.min', '', $file);
		$file = str_replace('.map', '', $file);

		if(!in_array($file, $includes)) {
			$formChooser = $formChooser."<option value=\"".$file."\"".($file == $default ? " selected" : "").">".$file."</option>\n";
			$includes[] = $file;
		}
	}

	return $formChooser."\n</select>\n";
}

if(isset($_GET['mode']) && $_GET['mode'] == "settings") {
	$settingstmpl = implode(" ", file("templates/users_settings.tmpl"));

	$users_settings_res = $class_db->db_query("SELECT tfastatus, tfasecret, theme, email FROM jts3servermodwebui_users WHERE id=".$_SESSION['userid']);
	$users_settings = mysqli_fetch_object($users_settings_res);

	$tfa = new TFA();

	if($users_settings->tfasecret == null) {
		$users_settings->tfasecret = $tfa->createSecret();
	}

	if(isset($_GET['tab']) && $_GET['tab'] == 'security') {
		$settingstmpl = str_replace('{tab_show}', "", $settingstmpl);
		$settingstmpl = str_replace('{tab_show_security}', "show active", $settingstmpl);
		$settingstmpl = str_replace('{active_tab}', "", $settingstmpl);
		$settingstmpl = str_replace('{security_tab}', "active", $settingstmpl);
	} else {
		$settingstmpl = str_replace('{tab_show}', "show active", $settingstmpl);
		$settingstmpl = str_replace('{tab_show_security}', "", $settingstmpl);
		$settingstmpl = str_replace('{active_tab}', "active", $settingstmpl);
		$settingstmpl = str_replace('{security_tab}', "", $settingstmpl);
	}

	$settingstmpl = str_replace('{userssettings_twofactor_activstat}', getYesNoComboBoxDef("userssettings_twofactor_activstat", (isset($_POST['userssettings_twofactor_activstat']) ? $_POST['userssettings_twofactor_activstat'] : $users_settings->tfastatus)), $settingstmpl);
	$settingstmpl = str_replace('{userssettings_twofactor_qrcode}', $tfa->getQRCodeImageAsDataUri($_SESSION['username'], $users_settings->tfasecret), $settingstmpl);
	$settingstmpl = str_replace('{userssettings_twofactor_secret}', $users_settings->tfasecret, $settingstmpl);

	$settingstmpl = str_replace('{userssettings_generell_theme}', getCSSListComboBoxDef("userssettings_generell_theme", (isset($_POST['userssettings_generell_theme']) ? $_POST['userssettings_generell_theme'] : ($users_settings->theme != null ? $users_settings->theme : (isset($configValues['webuisetting_themecss']) ? $configValues['webuisetting_themecss'] : 'bright')))), $settingstmpl);
	$settingstmpl = str_replace('{userssettings_generell_mail}', getEMailInput("userssettings_generell_mail", (isset($_POST['userssettings_generell_mail']) ? $_POST['userssettings_generell_mail'] : $users_settings->email), 18), $settingstmpl);

	$for_output = $settingstmpl;
} elseif(isset($_POST['mode']) && $_POST['mode'] == "settings") {

}

$for_output = $translation->replaceTranslationsForPage($for_output, "various");
$for_output = $translation->replaceTranslationsForPage($for_output, "bi_users");